/*
 Controllo Motor Shield per progetto Rover WiFi Arduino
 by HackLab Terni
*/

#include <Servo.h>

// SERVO MOTORI PAN TILT
Servo ServoMot_1;
Servo ServoMot_2;

// INIZIALIZZO LE POSIZIONI DEI SERVO PAN TILT
int posLR = 90;
int posUD = 110;

void setup()
{
  ServoMot_1.attach(5);
  ServoMot_2.attach(6);
  ServoMot_1.write(90);
  ServoMot_2.write(110);

  // Setup Motori DC
  pinMode(12, OUTPUT); // Inizializza DIRA pin
  pinMode(9, OUTPUT);  // Inizializza BRAKEA pin
  pinMode(13, OUTPUT); // Inizializza DIRB pin
  pinMode(8, OUTPUT);  // Inizializza BRAKEB pin

  Serial.begin(9600);

  delay(40000);

  ServoMot_1.write(posLR);
  ServoMot_2.write(posUD);
}

void loop()
{
  if (Serial.available()) {
    byte inByte = Serial.read();

    //------- PAN TILT WEBCAM ---------
    // Reset
    if (inByte == 'z') {
      posLR = 90;
      posUD = 110;
      ServoMot_1.write(posLR);
      ServoMot_2.write(posUD);
      delay(10);
    }
    // UP
    else if (inByte == 'u' && posUD <= 179) {
      posUD++;
      ServoMot_2.write(posUD);
      delay(10);
    }
    // DOWN
    else if (inByte == 'd' && posUD >= 82) {
      posUD--;
      ServoMot_2.write(posUD);
      delay(10);
    }
    // LEFT
    else if (inByte == 'l' && posLR >= 1) {
      posLR--;
      ServoMot_1.write(posLR);
      delay(10);
    }
    // RIGHT
    else if (inByte == 'r' && posLR <= 179) {
      posLR++;
      ServoMot_1.write(posLR);
      delay(10);
    }
    //--------------CONTROLLO MOTORI -------------------
    // AVANTI
    else if (inByte == 'a') {
      digitalWrite(12, HIGH); // Avanti Motore A
      digitalWrite(13, LOW);  // Avanti Motore B
      digitalWrite(9, LOW);   // Sblocco A
      digitalWrite(8, LOW);   // Sblocco B
      analogWrite(3, 100);    // Velocità Motore A
      analogWrite(11, 100);   // Velocità Motore B
      delay(30);
      digitalWrite(9, HIGH);  // Blocco Motore A
      digitalWrite(8, HIGH);  // Blocco Motore B
    }
    // INDIETRO
    else if (inByte == 'i') {
      digitalWrite(12, LOW);  // Indietro Motore A
      digitalWrite(13, HIGH); // Indietro Motore B
      digitalWrite(9, LOW);   // Sblocco A
      digitalWrite(8, LOW);   // Sblocco B
      analogWrite(3, 100);    // Velocità Motore A
      analogWrite(11, 100);   // Velocità Motore B
      delay(30);
      digitalWrite(9, HIGH);  // Blocco Motore A
      digitalWrite(8, HIGH);  // Blocco Motore B
    }
    // SINISTRA
    else if (inByte == 's') {
      digitalWrite(12, LOW);  // Indietro Motore A
      digitalWrite(13, LOW);  // Avanti Motore B
      digitalWrite(9, LOW);   // Sblocco A
      digitalWrite(8, LOW);   // Sblocco B
      analogWrite(3, 100);    // Velocità Motore A
      analogWrite(11, 100);   // Velocità Motore B
      delay(30);
      digitalWrite(9, HIGH);  // Blocco Motore A
      digitalWrite(8, HIGH);  // Blocco Motore B
    }
    // DESTRA
    else if (inByte == 'e') {
      digitalWrite(12, HIGH); // Avanti Motore A
      digitalWrite(13, HIGH); // Indietro Motore B
      digitalWrite(9, LOW);   // Sblocco A
      digitalWrite(8, LOW);   // Sblocco B
      analogWrite(3, 100);    // Velocità Motore A
      analogWrite(11, 100);   // Velocità Motore B
      delay(30);
      digitalWrite(9, HIGH);  // Blocco Motore A
      digitalWrite(8, HIGH);  // Blocco Motore B
    }
    // SINISTRA (solo un motore)
    else if (inByte == 't') {
      digitalWrite(13, LOW);  // Avanti Motore B
      digitalWrite(8, LOW);   // Sblocco B
      analogWrite(11, 100);   // Velocità Motore B
      delay(20);
      digitalWrite(8, HIGH);  // Blocco Motore B
    }
    // DESTRA (solo un motore)
    else if (inByte == 'f') {
      digitalWrite(12, HIGH); // Avanti Motore A
      digitalWrite(9, LOW);   // Sblocco A
      analogWrite(3, 100);    // Velocità Motore A
      delay(20);
      digitalWrite(9, HIGH);  // Blocco Motore A
    }
  }
}

